''
'' single wire serial link, 4 cycles/bit - demo
''
''        Author: Marko Lukat
'' Last modified: 2011/02/02
''       Version: 0.3
''
CON
  _clkmode = client#_clkmode
  _xinfreq = client#_xinfreq
  
OBJ
  client: "core.con.client.demoboard"
  reader: "proplink.rx.2048"
  writer: "proplink.tx.2048"
  
CON
  #0, XI_0, XI_1
  #0, XO_0, XO_1

  lcnt = 512
  
VAR
  long  payload[lcnt]                                   ' tx buffer
  long  storage[lcnt]                                   ' rx buffer
  
PUB selftest | n, rx, tx

  rx := constant(NEGX|XI_0)                             ' |
  tx := constant(NEGX|XO_0)                             ' link setup
  
  reader.init(-1, @rx)                                  ' start reader
  writer.init(-1, @tx)                                  ' start writer
  repeat while rx | tx                                  ' ... active

  repeat
    longfill(@storage{0}, 0, lcnt)                      ' clear incoming (?m <> 0)
    repeat n from 0 to constant(lcnt - 1)               ' |
      payload[n] := ?frqa                               ' pseudo-random payload
    
    rx := constant(lcnt << 16) | @storage{0}            ' register read request
    tx := constant(lcnt << 16) | @payload{0}            ' register send request
    repeat while rx                                     ' ... data ready
    dira[16..23] |= outa[16..23] := validate            ' validate incoming

PRI validate | n

  repeat n from 0 to constant(lcnt - 1)
    if payload[n] <> storage[n]
      abort

  return sequence[frqb++ & 15]

DAT                                                     ' LED sequence

sequence        byte    1, 2, 4, 8, 16, 32, 64, 128
                byte    128, 64, 32, 16, 8, 4, 2, 1

DAT             org     0                               ' pin validation

                res     (XI_0|XI_1) >> 5 <# 1           ' min(n, 1)
                res     (XO_0|XO_1) >> 5 <# 1           ' min(n, 1)

                fit     0
                
DAT